"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = __importDefault(require("./index"));
var mockFactory_1 = require("./test/mockFactory");
var azureInvokePlugin_1 = require("./plugins/invoke/azureInvokePlugin");
var azureLogsPlugin_1 = require("./plugins/logs/azureLogsPlugin");
var azureRemovePlugin_1 = require("./plugins/remove/azureRemovePlugin");
var azurePackagePlugin_1 = require("./plugins/package/azurePackagePlugin");
var azureDeployPlugin_1 = require("./plugins/deploy/azureDeployPlugin");
var azureLoginPlugin_1 = require("./plugins/login/azureLoginPlugin");
var azureApimServicePlugin_1 = require("./plugins/apim/azureApimServicePlugin");
var azureApimFunctionPlugin_1 = require("./plugins/apim/azureApimFunctionPlugin");
var azureProvider_1 = __importDefault(require("./provider/azureProvider"));
describe("Azure Index", function () {
    it("contains all registered plugins", function () {
        var sls = mockFactory_1.MockFactory.createTestServerless();
        var options = mockFactory_1.MockFactory.createTestServerlessOptions();
        new index_1.default(sls, options);
        sls.setProvider = jest.fn();
        expect(sls.setProvider).toBeCalledWith("azure", new azureProvider_1.default(sls));
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azurePackagePlugin_1.AzurePackagePlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureInvokePlugin_1.AzureInvokePlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureLogsPlugin_1.AzureLogsPlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureRemovePlugin_1.AzureRemovePlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureLoginPlugin_1.AzureLoginPlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureDeployPlugin_1.AzureDeployPlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureApimServicePlugin_1.AzureApimServicePlugin);
        expect(sls.pluginManager.addPlugin).toBeCalledWith(azureApimFunctionPlugin_1.AzureApimFunctionPlugin);
    });
});
