import Serverless from "serverless";
import { AuthResponse, AzureTokenCredentialsOptions, InteractiveLoginOptions } from "@azure/ms-rest-nodeauth";
export interface AzureLoginOptions extends Serverless.Options {
    subscriptionId?: string;
}
export declare class AzureLoginService {
    /**
     * Logs in via service principal login if environment variables are
     * set or via interactive login if environment variables are not set
     * @param options Options for different authentication methods
     */
    static login(options?: AzureTokenCredentialsOptions | InteractiveLoginOptions): Promise<AuthResponse>;
    static interactiveLogin(options?: InteractiveLoginOptions): Promise<AuthResponse>;
    static servicePrincipalLogin(clientId: string, secret: string, tenantId: string, options: AzureTokenCredentialsOptions): Promise<AuthResponse>;
}
