"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var loginService_1 = require("./loginService");
jest.mock("open");
var open_1 = __importDefault(require("open"));
jest.mock("@azure/ms-rest-nodeauth");
var nodeauth = __importStar(require("@azure/ms-rest-nodeauth"));
jest.mock("../plugins/login/utils/simpleFileTokenCache");
var simpleFileTokenCache_1 = require("../plugins/login/utils/simpleFileTokenCache");
describe("Login Service", function () {
    it("logs in interactively with no cached login", function () { return __awaiter(_this, void 0, void 0, function () {
        var emptyObj;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Ensure env variables are not set
                    delete process.env.azureSubId;
                    delete process.env.azureServicePrincipalClientId;
                    delete process.env.azureServicePrincipalPassword;
                    delete process.env.azureServicePrincipalTenantId;
                    simpleFileTokenCache_1.SimpleFileTokenCache.prototype.isEmpty = jest.fn(function () { return true; });
                    emptyObj = { subscriptions: [] };
                    Object.defineProperty(nodeauth, "interactiveLoginWithAuthResponse", { value: jest.fn(function (_obj) { return emptyObj; }) });
                    return [4 /*yield*/, loginService_1.AzureLoginService.login()];
                case 1:
                    _a.sent();
                    expect(simpleFileTokenCache_1.SimpleFileTokenCache).toBeCalled();
                    expect(open_1.default).toBeCalledWith("https://microsoft.com/devicelogin");
                    expect(nodeauth.interactiveLoginWithAuthResponse).toBeCalled();
                    expect(simpleFileTokenCache_1.SimpleFileTokenCache.prototype.addSubs).toBeCalledWith(emptyObj.subscriptions);
                    return [2 /*return*/];
            }
        });
    }); });
    it("logs in with a cached login", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Ensure env variables are not set
                    delete process.env.azureSubId;
                    delete process.env.azureServicePrincipalClientId;
                    delete process.env.azureServicePrincipalPassword;
                    delete process.env.azureServicePrincipalTenantId;
                    simpleFileTokenCache_1.SimpleFileTokenCache.prototype.isEmpty = jest.fn(function () { return false; });
                    simpleFileTokenCache_1.SimpleFileTokenCache.prototype.first = jest.fn(function () { return ({ userId: "" }); });
                    return [4 /*yield*/, loginService_1.AzureLoginService.login()];
                case 1:
                    _a.sent();
                    expect(simpleFileTokenCache_1.SimpleFileTokenCache).toBeCalled();
                    expect(nodeauth.DeviceTokenCredentials).toBeCalled();
                    expect(simpleFileTokenCache_1.SimpleFileTokenCache.prototype.listSubscriptions).toBeCalled();
                    return [2 /*return*/];
            }
        });
    }); });
    it("logs in with a service principal", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Set environment variables
                    process.env.azureSubId = "azureSubId";
                    process.env.azureServicePrincipalClientId = "azureServicePrincipalClientId";
                    process.env.azureServicePrincipalPassword = "azureServicePrincipalPassword";
                    process.env.azureServicePrincipalTenantId = "azureServicePrincipalTenantId";
                    return [4 /*yield*/, loginService_1.AzureLoginService.login()];
                case 1:
                    _a.sent();
                    expect(nodeauth.loginWithServicePrincipalSecretWithAuthResponse).toBeCalledWith("azureServicePrincipalClientId", "azureServicePrincipalPassword", "azureServicePrincipalTenantId", undefined // would be options
                    );
                    return [2 /*return*/];
            }
        });
    }); });
});
