"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mockFactory_1 = require("../test/mockFactory");
var bindings_1 = require("./bindings");
var mock_fs_1 = __importDefault(require("mock-fs"));
describe("Bindings", function () {
    var sls;
    afterEach(function () {
        mock_fs_1.default.restore();
    });
    beforeEach(function () {
        sls = mockFactory_1.MockFactory.createTestServerless();
        sls.config.servicePath = process.cwd();
        jest.clearAllMocks();
    });
    it("should get bindings metadata from serverless", function () {
        expect(sls).not.toBeNull();
        bindings_1.BindingUtils.getBindingsMetaData(sls);
        expect(sls.cli.log).toBeCalledWith("Parsing Azure Functions Bindings.json...");
    });
});
